package top.ninwoo.cloud.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.multipart.MultipartFile;
import top.ninwoo.api.CnfData;
import top.ninwoo.api.Picture;
import top.ninwoo.cloud.service.cpcTrans.CpcTrans;
import top.ninwoo.cloud.service.dbctrans.DbcTrans;
import top.ninwoo.cloud.service.findService.FindServiceImpl;

import javax.annotation.Resource;
import javax.imageio.ImageIO;
import java.io.*;
import java.text.ParseException;
import java.util.LinkedList;
import java.util.concurrent.ConcurrentHashMap;

@Controller
public class DataCtrl {

    @Autowired
    CpcTrans cpcTrans;

    @Autowired
    DbcTrans dbcTrans;

    @Resource
    private RestTemplate restTemplate;

    @RequestMapping(value = "/cpcTrans",method = RequestMethod.GET)
    public String upload() {
        return "cpcTrans";
    }

    @RequestMapping(value = "/cpcTrans")
    @ResponseBody
    public String CpcTrans(@RequestParam("file") MultipartFile file, @RequestParam("fileId") String fileId) {
        if(!file.isEmpty()){
            try {
                //包装图片
                Picture picture = cpcTrans.packagePic(ImageIO.read(file.getInputStream()), fileId);
                //包装数据包
                LinkedList<CnfData> cnfData = cpcTrans.packageData(picture);
                //发送
                for (CnfData data : cnfData) {
                    cpcTrans.sendData(data, data.getNextIPHop());
                }
            } catch (FileNotFoundException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (IOException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (ParseException e) {
                e.printStackTrace();
            }
            return "上传成功！";
        } else {
            return "上传失败，因为文件是空的.";
        }
    }

    @PostMapping(value = "/dbcTrans")
    @ResponseBody
    public String DbcTrans(@RequestParam("file") MultipartFile file, @RequestParam("fileId") String fileId) {
        if(!file.isEmpty()){
            try {
                //包装图片
                Picture picture = dbcTrans.packagePic(ImageIO.read(file.getInputStream()), fileId);
                //包装数据包
                LinkedList<CnfData> cnfData = dbcTrans.packageData(picture);
                //发送
                for (CnfData data : cnfData) {
                    dbcTrans.sendData(data, data.getNextIPHop());
                }
            } catch (FileNotFoundException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (IOException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (ParseException e) {
                e.printStackTrace();
            }
            return "上传成功！";
        } else {
            return "上传失败，因为文件是空的.";
        }
    }

    @GetMapping(value = "/getImg")
    @ResponseBody
    public String GetAllImg(){
        FindServiceImpl findService = new FindServiceImpl();
        ConcurrentHashMap<String, String> ipool  = findService.findIPool();
        for (int i = 1; i < ipool.size()+1; i++) {
            String str = "sate"+i;
            System.out.println(str);
            String ip = ipool.get(str);
            System.out.println(ip);
            GetImg(str,ip);
        }
        return "sucess";
    }

    public void GetImg(String sataname, String ip){
        String IP =ip + ":8083";
        byte[][] res = restTemplate.getForObject("http://" + IP +"/getImg",byte[][].class);
        if(res == null){
            System.out.println(sataname+"no picture");
            return;
        }
        //创建一个字节输出流
        OutputStream outputStream = null;
        try {
            int i = 0;
            for (byte[] re : res) {
                //得到新路径
                String path = "/home/dell/show/public/assets/cpc_images/"+sataname+"-"+i+".jpg";
                outputStream = new FileOutputStream(path);
                //将图片输处到流中
                outputStream.write(re);
                //刷新
                outputStream.flush();
                i++;
            }

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                //关闭
                if (outputStream != null){
                    outputStream.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    //获取计算能力
    @GetMapping("/getComputing")
    @ResponseBody
    public LinkedList<Double> getComputing() {
        FindServiceImpl findService = new FindServiceImpl();
        ConcurrentHashMap<String, String> ipool  = findService.findIPool();
        LinkedList<Double> cpuCom = new LinkedList<>();
        for (int i = 1; i < ipool.size(); i++) {
            String str = "sate"+i;
            String ip = ipool.get(str);
            double res = cpcTrans.sendCpuCtr(ip);
            cpuCom.add(res);
        }
        return cpuCom;
    }

    //获取计算能力
    @GetMapping("/download")
    @ResponseBody
    public String download() {
        return null;
    }

    @GetMapping("/testCpc")
    @ResponseBody
    public String CpcTest() throws ParseException, IOException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\2.jpg");
        Picture picture = cpcTrans.packagePic(ImageIO.read(file), "123");
        //包装数据包
        LinkedList<CnfData> cnfData = cpcTrans.packageData(picture);
        return cpcTrans.sendData(cnfData.get(0),cnfData.get(0).getNextIPHop());
    }

    @GetMapping("/testDbc")
    @ResponseBody
    public CnfData DbcTest() throws IOException, ParseException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\2.jpg");
        Picture picture = dbcTrans.packagePic(ImageIO.read(file), "123");
        LinkedList<CnfData> cnfData = dbcTrans.packageData(picture, "sate3");
        return cnfData.get(0);
    }

    @GetMapping("/test")
    @ResponseBody
    public CnfData Test1() throws ParseException, IOException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\1.jpg");
        Picture picture = cpcTrans.packagePic(ImageIO.read(file), "123");
        //包装数据包
        LinkedList<CnfData> cnfData = cpcTrans.packageData(picture);
        //String res = cpcTrans.sendData(cnfData.get(0),"127.0.0.1");
        return cnfData.get(0);
    }
    @GetMapping("/testlt")
    @ResponseBody
    public String[][] LtTest() throws IOException, ParseException {
        File file = new File("C:\\Users\\Elf\\Desktop\\test\\2.jpg");
        Picture picture = dbcTrans.packagePic(ImageIO.read(file), "123");
        return dbcTrans.getIt();
    }


}

